'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _construct = require('@babel/runtime/helpers/construct');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var React = require('react');

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "::highlight(results) {\n    background-color: yellow;\n}";
styleInject(css_248z);

function HighlightWords(_ref) {
  var words = _ref.words,
    children = _ref.children;
  var ref = React.useRef(null);
  var textNodes = React.useMemo(function () {
    var highlightElement = ref.current;
    if (!highlightElement) {
      return [];
    }
    var treeWalker = document.createTreeWalker(highlightElement, NodeFilter.SHOW_TEXT);
    var allTextNodes = [];
    var currentNode = treeWalker.nextNode();
    while (currentNode) {
      allTextNodes.push(currentNode);
      currentNode = treeWalker.nextNode();
    }
    return allTextNodes;
  }, [ref.current]);
  React.useEffect(function () {
    if (!CSS.highlights) {
      console.log('CSS Custom Highlight API not supported.');
      return;
    }
    CSS.highlights.clear();
    if (!words) return;
    var ranges = textNodes.map(function (el) {
      return {
        el: el,
        text: el.textContent
      };
    }).map(function (_ref2) {
      var text = _ref2.text,
        el = _ref2.el;
      var indices = [];
      var startPos = 0;
      while (text && startPos < text.length) {
        var index = text.indexOf(words, startPos);
        if (index === -1) break;
        indices.push(index);
        startPos = index + words.length;
      }
      return indices.map(function (index) {
        var range = new Range();
        range.setStart(el, index);
        range.setEnd(el, index + words.length);
        return range;
      });
    });
    // @ts-ignore
    var searchResultsHighlight = _construct(Highlight, _toConsumableArray(ranges.flat())); // @ts-ignore
    window.s = searchResultsHighlight;
    CSS.highlights.set('results', searchResultsHighlight);
  }, [words]);
  return /*#__PURE__*/React.createElement("div", {
    ref: ref
  }, children);
}

exports.default = HighlightWords;
//# sourceMappingURL=index.js.map
